"""
    Search API reference

    Service name    # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

import nulltype  # noqa: F401

from pensando_dss.psm.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)


class SearchPolicySearchRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'action': (str,),  # noqa: E501
            'app': (str,),  # noqa: E501
            'destination_address': (str,),  # noqa: E501
            'from_ip_address': (str,),  # noqa: E501
            'from_workload_group': (str,),  # noqa: E501
            'kinds': ([str],),  # noqa: E501
            'name': (str,),  # noqa: E501
            'namespace': (str,),  # noqa: E501
            'port': (str,),  # noqa: E501
            'protocol': (str,),  # noqa: E501
            'source_address': (str,),  # noqa: E501
            'tenant': (str,),  # noqa: E501
            'to_ip_address': (str,),  # noqa: E501
            'to_workload_group': (str,),  # noqa: E501
            'translated_destination_address': (str,),  # noqa: E501
            'translated_destination_port': (str,),  # noqa: E501
            'translated_source_address': (str,),  # noqa: E501
            'virtual_routers': ([str],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'action': 'action',  # noqa: E501
        'app': 'app',  # noqa: E501
        'destination_address': 'destination-address',  # noqa: E501
        'from_ip_address': 'from-ip-address',  # noqa: E501
        'from_workload_group': 'from-workload-group',  # noqa: E501
        'kinds': 'kinds',  # noqa: E501
        'name': 'name',  # noqa: E501
        'namespace': 'namespace',  # noqa: E501
        'port': 'port',  # noqa: E501
        'protocol': 'protocol',  # noqa: E501
        'source_address': 'source-address',  # noqa: E501
        'tenant': 'tenant',  # noqa: E501
        'to_ip_address': 'to-ip-address',  # noqa: E501
        'to_workload_group': 'to-workload-group',  # noqa: E501
        'translated_destination_address': 'translated-destination-address',  # noqa: E501
        'translated_destination_port': 'translated-destination-port',  # noqa: E501
        'translated_source_address': 'translated-source-address',  # noqa: E501
        'virtual_routers': 'virtual-routers',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """SearchPolicySearchRequest - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            action (str): Action, e.g. PERMIT, DENY or REJECT/CLEAR, PROTECT_PERMISSIVE or PROTECT_STRICT.. [optional]  # noqa: E501
            app (str): App specification,  predefined apps and alg config.. [optional]  # noqa: E501
            destination_address (str): Destination Address to be used for NAT policy search, can be either an IP address or IP collection name.. [optional]  # noqa: E501
            from_ip_address (str): Inbound ip-address, use any to refer to all ipaddresses eg: 10.1.1.1, any.. [optional]  # noqa: E501
            from_workload_group (str): Inbound workload group.. [optional]  # noqa: E501
            kinds ([str]): Kind of the policy that this request should act on. It should be either NetworkSecurityPolicy, IPSecPolicy or NATPolicy.. [optional]  # noqa: E501
            name (str): Name is optional. If provided policy-search will be limited to the specified policy of the given name on the given kind. If empty, then all the policies of the given kind will be searched.. [optional]  # noqa: E501
            namespace (str): Namespace is optional. If provided policy-search will be limited to the specified namespace.. [optional] if omitted the server will use the default value of "default"  # noqa: E501
            port (str): TCP or UDP Port number.. [optional]  # noqa: E501
            protocol (str): Protocol eg: tcp, udp, icmp.. [optional]  # noqa: E501
            source_address (str): NAT policy related fields Source Address to be used for NAT policy search, can be either an IP address or IP collection name.. [optional]  # noqa: E501
            tenant (str): Tenant Name, to perform query within a Tenant's scope. The default tenant is \"default\". In the backend this field gets auto-filled & validated by apigw-hook based on user login context.. [optional] if omitted the server will use the default value of "default"  # noqa: E501
            to_ip_address (str): Outbound ip-address, use any to refer to all ipaddresses eg: 20.1.1.1, any.. [optional]  # noqa: E501
            to_workload_group (str): Outbound workload group.. [optional]  # noqa: E501
            translated_destination_address (str): Translated Destination Address to be used for NAT policy search, can be either an IP address or IP collection name.. [optional]  # noqa: E501
            translated_destination_port (str): Translated Destination Port to be use for NAT policy search.. [optional]  # noqa: E501
            translated_source_address (str): Translated Source Address to be used for NAT policy search, can be either an IP address or IP collection name.. [optional]  # noqa: E501
            virtual_routers ([str]): VirtualRouters to be use for searching Security Policy / IPSec Policy / NAT Policy based on VRF association.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
