"""
    Telemetry_query API reference

    Service name    # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

import nulltype  # noqa: F401

from pensando_dss.psm.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from pensando_dss.psm.model.fields_selector import FieldsSelector
    from pensando_dss.psm.model.telemetry_query_bottom_spec import TelemetryQueryBottomSpec
    from pensando_dss.psm.model.telemetry_query_pagination_spec import TelemetryQueryPaginationSpec
    from pensando_dss.psm.model.telemetry_query_top_spec import TelemetryQueryTopSpec
    globals()['FieldsSelector'] = FieldsSelector
    globals()['TelemetryQueryBottomSpec'] = TelemetryQueryBottomSpec
    globals()['TelemetryQueryPaginationSpec'] = TelemetryQueryPaginationSpec
    globals()['TelemetryQueryTopSpec'] = TelemetryQueryTopSpec


class TelemetryQueryMetricsQuerySpec(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('function',): {
            'NONE': "none",
            'MEAN': "mean",
            'MAX': "max",
            'MEDIAN': "median",
            'DERIVATIVE': "derivative",
            'DIFFERENCE': "difference",
            'LAST': "last",
            'TOP': "top",
            'BOTTOM': "bottom",
            'MIN': "min",
            'FIRST': "first",
            'SUM': "sum",
        },
        ('sort_order',): {
            'ASCENDING': "ascending",
            'DESCENDING': "descending",
        },
    }

    validations = {
        ('group_by_field',): {
            'regex': {
                'pattern': r'^[a-zA-Z0-9][\w\-\.\,]*[a-zA-Z0-9]$',  # noqa: E501
            },
        },
        ('name',): {
            'regex': {
                'pattern': r'^[a-zA-Z0-9][\w\-\.]*[a-zA-Z0-9]$',  # noqa: E501
            },
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'api_version': (str,),  # noqa: E501
            'bottom_param': (TelemetryQueryBottomSpec,),  # noqa: E501
            'end_time': (datetime,),  # noqa: E501
            'fields': ([str],),  # noqa: E501
            'function': (str,),  # noqa: E501
            'group_by_field': (str,),  # noqa: E501
            'group_by_time': (str,),  # noqa: E501
            'kind': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'pagination': (TelemetryQueryPaginationSpec,),  # noqa: E501
            'selector': (FieldsSelector,),  # noqa: E501
            'sort_order': (str,),  # noqa: E501
            'start_time': (datetime,),  # noqa: E501
            'subquery': (TelemetryQueryMetricsQuerySpec,),  # noqa: E501
            'top_param': (TelemetryQueryTopSpec,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'api_version': 'api-version',  # noqa: E501
        'bottom_param': 'bottom-param',  # noqa: E501
        'end_time': 'end-time',  # noqa: E501
        'fields': 'fields',  # noqa: E501
        'function': 'function',  # noqa: E501
        'group_by_field': 'group-by-field',  # noqa: E501
        'group_by_time': 'group-by-time',  # noqa: E501
        'kind': 'kind',  # noqa: E501
        'name': 'name',  # noqa: E501
        'pagination': 'pagination',  # noqa: E501
        'selector': 'selector',  # noqa: E501
        'sort_order': 'sort-order',  # noqa: E501
        'start_time': 'start-time',  # noqa: E501
        'subquery': 'subquery',  # noqa: E501
        'top_param': 'top-param',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """TelemetryQueryMetricsQuerySpec - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            api_version (str): [optional]  # noqa: E501
            bottom_param (TelemetryQueryBottomSpec): [optional]  # noqa: E501
            end_time (datetime): EndTime selects all metrics with timestamp less than the EndTime, example 2018-09-18T00:12:00Z.. [optional]  # noqa: E501
            fields ([str]): Fields select the metric fields to be included in the result Empty will include all fields, must contain at least one non-tag field. Must start and end with alpha numeric and can have alphanumeric, -, _, .. [optional]  # noqa: E501
            function (str): Functions specify an operation function to be applied, example mean()/max().. [optional] if omitted the server will use the default value of "none"  # noqa: E501
            group_by_field (str): GroupbyField groups series based on the field specified. Must start and end with alpha numeric and can have alphanumeric, -, _, . and ,.. [optional]  # noqa: E501
            group_by_time (str): GroupbyTime groups series based on the interval specified. Should be a valid time duration.. [optional]  # noqa: E501
            kind (str): [optional]  # noqa: E501
            name (str): Name is the name of the API object. Must start and end with alpha numeric and can have alphanumeric, -, _, .. [optional]  # noqa: E501
            pagination (TelemetryQueryPaginationSpec): [optional]  # noqa: E501
            selector (FieldsSelector): [optional]  # noqa: E501
            sort_order (str): SortOrder specifies time ordering of results.. [optional] if omitted the server will use the default value of "ascending"  # noqa: E501
            start_time (datetime): StartTime selects all metrics with timestamp greater than the StartTime, example 2018-10-18T00:12:00Z.. [optional]  # noqa: E501
            subquery (TelemetryQueryMetricsQuerySpec): [optional]  # noqa: E501
            top_param (TelemetryQueryTopSpec): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
